// -------------------------------------------------------------------------
//  enchant.js 単語を一文字ずつ当てる問題kai
// 					created at 2013-08-23 on MRGARITA.NET
// -------------------------------------------------------------------------
/*
 * 必須
 */
enchant();

/*
 * 定数
 */
var SCREEN_WIDTH = 320;		// 幅
var SCREEN_HEIGHT = 320;		// 高さ

/*
 * グローバル変数
 */
var game = null;							// このゲーム
var barbarNowTime;						// 現在時刻
var barbarStartTime;						// バーのスタート時刻
var bar = null;							// カウントダウンバー
var labelTime = null;						// カウントダウン時刻
var labelMondai = null;					// 問題表示ラベル
var labelSentaku = new Array();			// 選択肢表示ラベル
var result = null;							// チェックした文字列
var mondaiNo = 0;						// 問題番号
var tangoNo = 0;							// 単語の現在位置
var mode;								// ゲームモード RUN/GAMEOVER
var startTime;							// 処理待ち用スタート時刻
var nowTime;							// 処理待ち用用現在時刻
// 定数
var IMG_BAR = "bar.png";
var COUNTDOWN = 10;					// カウントダウン秒数
// ゲームモード
var RUN = 1;							// ゲーム実行中
var GAMEOVER = 0;						// ゲームオーバー
var NEXTQUESTION = 2;					// 次の問題
var CLEAR = 3;							// ゲームクリア
var WAIT = 4;							// 次の問題への処理待ち

/*
 * 汎用処理
 */
var rnd = function(n){
	return Math.floor(Math.random() *n);
}

/*
 * バークラス
 */
var Bar = Class.create(Sprite, {
	initialize: function(){
		Sprite.call(this, 32, 32);
		this.image = game.assets[IMG_BAR];
		this.moveTo(0, SCREEN_HEIGHT/2);
		this.zobun = game.width / (COUNTDOWN*10);	// 増分幅の設定（100分の1秒用に10を掛けている）
		console.log("増分=" + this.zobun);
		this.timer = game.frame + this.zobun;
		this.width = SCREEN_WIDTH;
		this.update = this.countdown;
	},
	reset: function(){
		this.timer = game.frame + this.zobun;
		this.width = SCREEN_WIDTH;
		this.update = this.countdown;
	},
	countdown: function(){
		if(game.frame > this.timer){
			this.width -= this.zobun;
			if(this.width < this.zobun) this.width = 1;
			this.timer += this.zobun;
		}
		if(this.width <= 1){
			game.rootScene.backgroundColor = "red";
			this.update = this.stop;
		}
	},
	wait: function(){
	},
	stop: function(){
		this.update = this.wait;
	},
	hide: function(){
		this.visible = false;
	},
	onenterframe: function(){
		this.update();
	},
});

/*
 * 秒数ラベルクラス
 */
var LabelTime = Class.create(Label, {
	initialize: function(){
		Label.call(this);
		this.moveTo(SCREEN_WIDTH/2-64, SCREEN_HEIGHT/2-32);
		this.font = "64px 'メイリオ', 'Osaka' ";
		this.color = "#fff";
		this.opacity = 0.6;
		barStartTime = new Date().getTime();
		this.update = this.countdown;
	},
	reset: function(){
		barStartTime = new Date().getTime();
		this.update = this.countdown;
	},
	countdown: function(){
		barNowTime = new Date().getTime();
		var leftTime = COUNTDOWN - (barNowTime - barStartTime)/1000;
		leftTime = Math.round(leftTime);
		this.text = leftTime + "秒";
		if(leftTime <= 0){
			this.update = this.stop;
		}
	},
	wait: function(){
	},
	stop: function(){
		this.update = this.wait;
	},
	hide: function(){
		this.visible = false;
	},
	onenterframe: function(){
		this.update();
	},
});

/*
 * 問題表示クラス
 */
var Mondai = Class.create(Label, {
	initialize: function(){
		Label.call(this);
		this.moveTo(24, 48);
		this.font ="32px 'メイリオ'";
		this.text = mondai[mondaiNo][0];
	},
	set: function(){
		this.text = mondai[mondaiNo][0];
	},
});

/*
 * 選択肢表示クラス
 */
var Sentaku = Class.create(Label, {
	initialize: function(x, y){
		Label.call(this);
		this.font = "24px 'メイリオ' ";
		this.moveTo(x, y);
		this.seikai = false;	// 正解かどうか？
	},
	setText: function(text){
		this.text = text;
	},
	ontouchstart: function(){
		if(mode == WAIT || mode == GAMEOVER || mode == CLEAR) return;
		result.add(this.text);		// タッチ履歴を表示
		if(this.seikai == true){	// 正解の時
			this.seikai = false;
			tangoNo++;
			console.log("tangoNo = " + tangoNo);
			if(tangoNo == mondai[mondaiNo][1].length){
				mode = NEXTQUESTION;
			}
			else{
				setTango();
			}
		}
		else{					// 不正解のとき
			mode = GAMEOVER;
			stopBar();
			game.rootScene.backgroundColor = "red";
		}
	},
});

/*
 * 入力した文字の履歴ラベルクラス
 */
var Result = Class.create(Label, {
	initialize: function(){
		Label.call(this);
		this.font = "32px 'メイリオ' ";
		this.color = "#ddd";
		this.text = "";
		this.moveTo(24, SCREEN_HEIGHT - 48);
	},
	add: function(text){
		this.text = this.text + text;
	},
	reset: function(){
		this.text = "";
	},
	setText: function(text){
		this.text = text;
	},
});

/*
 * 選択肢の単語を設定する関数
 */
var setTango = function(){
	var no = new Array(4);
	console.log("tango.length = " + tango.length);
	do{
		for(var i=0; i<4; i++){
			no[i] = rnd(tango.length)
		}
		var check = true;
		for(var i=1; i<4; i++){
			if(no[0] === no[i]){
				check = false;
				console.log("no[0] = " + no[0] + " no[" + i + "] = " + no[i]);
			}
		}
	} while(check == false);
	
	for(var i=0; i<labelSentaku.length; i++){
		labelSentaku[i].setText( tango[ no[i] ] );
	}
	// 正解文字を設定
	var seikaiCheck = true;
	for(var i=0; i<labelSentaku.length; i++){
		if(labelSentaku[i].text == mondai[mondaiNo][1][tangoNo]){	// 正解文字が存在しているか？
			labelSentaku[i].seikai = true;
			seikaiCheck = false;
		}
	}
	
	if(seikaiCheck){	// 正解文字が存在しないなら設定
		var seikai = rnd(labelSentaku.length);
		labelSentaku[seikai].setText( mondai[mondaiNo][1][tangoNo] );
		labelSentaku[seikai].seikai = true;
	}
};

/*
 * 次の問題を表示する
 */
var nextQuestion = function(){
	mondaiNo++;
	// 問題がもうない
	if(mondaiNo >= mondai.length){
		mode = CLEAR;
	}
	else{
		// 問題
		labelMondai.set();
		// 選択肢
		result.reset();
		tangoNo = 0;
		setTango();
		// タイマーをリセット
		resetBar();
	}
};

/*
 * バーをリセットする
 */
var resetBar = function(){
	labelTime.reset();
	bar.reset();
};

/*
 * バーをストップする
 */
var stopBar = function(){
	labelTime.stop();
	bar.stop();
};

/*
 * バーを隠す
 */
var hideBar = function(){
	labelTime.hide();
	bar.hide();
};

/*
 * メイン
 */

window.onload = function(){
	// ゲームオブジェクト生成
	game = new Game(SCREEN_WIDTH, SCREEN_HEIGHT);
	
	// 画像の読み込み
	game.preload("bar.png");
	
	// ゲーム開始時の処理
	game.onload = function(){
		console.log("問題数 = " + mondai.length);
		mode = RUN;

		var scene = game.rootScene;
		scene.backgroundColor = "skyblue";
		
		// バーの生成と表示
		bar = new Bar();
		scene.addChild(bar);
		
		// 秒数ラベルの生成と表示
		labelTime = new LabelTime();
		scene.addChild(labelTime);
		
		// 問題表示クラスの生成と表示
		labelMondai = new Mondai();
		scene.addChild(labelMondai);
		
		// 選択肢クラスの生成と表示
		for(var i=0; i<4; i++){
			labelSentaku[i] = new Sentaku(50+i*64, 240);
			scene.addChild(labelSentaku[i]);
		}
		
		// 入力した文字の履歴表示クラスの生成と表示
		result = new Result();
		scene.addChild(result);
		
		// 選択肢の一文字を設定
		setTango();
		
		// シーン更新時の処理
		scene.onenterframe = function(){
			if(mode == NEXTQUESTION){
				mode = WAIT;
				stopBar();
				startTime = new Date().getTime();
			}
			else if(mode == WAIT){	// 次の問題への処理待ち
				nowTime = new Date().getTime();
				var passedTime = (nowTime - startTime) / 1000;
				if(passedTime >= 2.0){	// 2秒後に再開
					mode = RUN;
					nextQuestion();
					resetBar();
				}
			}
			else if(mode == CLEAR){
				hideBar();
				game.rootScene.backgroundColor = "yellowgreen";
				result.setText("ゲームクリア！！！");
			}
		};
		// シーンタッチ時の処理
		scene.ontouchstart = function(){
		};
	};
	game.start();
};
